Status: Closed

Priority: Normal

Assignee:

Category: Data Provider/Oracle

Affected QGIS version:2.4.0 Regression?: No
Operating System: Easy fix?: No

Pull Request or Patch supplied: Resolution: end of life
Crashes QGIS or corrupls data: Copied to github as #: 19446
Description

Hello,

since QGis 2.4, we can load our own queries (sub-queries) instead of tables.

The queries can be added in a QGS project file by replacing the name of the table with the content of the query, enclosed by parenthesis.
QGis can open those queries and show the data on the canvas map but it emits an error log in the following form:

SQL : SELECT DISTINCT t."GEOM".SDO_GTYPE,t."GEOM".SDO_SRID FROM (SELECT "GEOM" FROM ""."(SELECT GID, GEOM
FROM TEST_QGIS_S

)" WHERE "GEOM" IS NOT NULL AND rownum<=100) t WHERE NOT t."GEOM" IS NULL

erreur : ORA-01741: illegal zero-length identifier

Impossible de préparer la déclaration

The problem is that this query is not valid to Oracle. | believe that this query is made by QgsOracleConn::retrieveLayerTypes method
when trying to determinate the geometry type.
According to the code, the query only handle table names and not query definitions.

This query should be modified to handle subqueries by deleting the quotes and the dot and ommitting the owner
(layerProperty.ownerName).

Thanks for fixing this (non blocking but just annoying) bug in order to increase dynamic SQL queries support of QGis...

History

#1 - 2017-05-01 01:08 AM - Giovanni Manghi
- Easy fix? set to No

- Regression? set to No

#2 - 2017-09-08 01:35 PM - Jiirgen Fischer
- Assignee deleted (Jirgen Fischer)

#3 - 2019-03-09 03:12 PM - Giovanni Manghi

- Resolution set to end of life
- Status changed from Open to Closed

End of life notice: QGIS 2.18 LTR

Source:

2025-12-15 1/2



https://github.com/qgis/QGIS/blob/master/src/providers/oracle/qgsoracleconn.cpp#L371

http://blog.qgis.org/2019/03/09/end-of-life-notice-qgis-2-18-ltr/
